require 'robut/plugin'
require 'net/http'
require 'json'
require 'ostruct'
require 'robut/plugin/giphy/base'

class Robut::Plugin::Giphy
  include Robut::Plugin
  include Robut::Plugin::Giphy::Base

  def self.configuration
    @config ||=  OpenStruct.new
  end

  def self.configure
    yield(configuration) if block_given?
  end

  desc "giphy <subject> - searches for and displays a gif matching <subject> from giphy"
  match /^giphy ([^;]+)$/, :sent_to_me => true do |gif|
    begin
      uri = giphy_uri(gif)
      reply(uri ? "#{uri}\nPowered by Giphy" : "Sorry, I couldn't find a gif for that.")
    rescue
      reply('Giphy returned an error')
    end
  end

  private
  def self.api_key
    Robut::Plugin::Giphy.configuration.api_key || 'dc6zaTOxFJmzC'
  end

  def self.rating
    Robut::Plugin::Giphy.configuration.rating || 'pg'
  end
end

